//Scripts for supporting extension http://www.mediawiki.org/wiki/Extension:HarvardReferences

var HrvHighlight = new function(){

var state = "";

function setBackground(prm_name){
	var anchorTags = document.getElementsByTagName("sup");
	for (var i = 0; i < anchorTags.length ; i++){
		var ob1=anchorTags[i];
		if(ob1.id.indexOf("harv_note-"+prm_name)==0){
			ob1.parentNode.style.backgroundColor="#DDEEFF";
		}else if(ob1.id.indexOf("harv_note-")==0){
			ob1.parentNode.style.backgroundColor="";
		}
	}
}

//when user clicks to ref in article text
function setRef(prm_name, prm_n){
	var anchorTags = document.getElementsByTagName("sup");
	for (var i = 0; i < anchorTags.length ; i++){
		var ob1=anchorTags[i];
		if(ob1.id=="harv_ref-"+prm_name+"-"+prm_n){
			ob1.style.backgroundColor="#AAAAAA"; //link, clicked in article
		}else if(ob1.id=="harv_note-"+prm_name+"-"+prm_n){	
			ob1.style.backgroundColor="yellow"; // number back link
		}else if(ob1.id=="harv_note-"+prm_name){	
			ob1.style.backgroundColor="yellow"; //big back link
		}else{	
			ob1.style.backgroundColor="";
		}
	}
	setBackground(prm_name);
}

//when user clicks to big backlink from bibliography
function setBack(prm_name){
	var anchorTags = document.getElementsByTagName("sup");
	for (var i = 0; i < anchorTags.length ; i++){
		var ob1=anchorTags[i];
		if(ob1.id.indexOf("harv_ref-"+prm_name+"-")==0){
			ob1.style.backgroundColor="#AAAAAA";//all links in article
		}else if(ob1.id=="harv_note-"+prm_name){
			ob1.style.backgroundColor="yellow"; //big back link
		}else{	
			ob1.style.backgroundColor="";
		}
	}
	setBackground(prm_name);
}

//when user clicks to small (number) backlink from bibliography
function setNote(prm_name, prm_n){
	var anchorTags = document.getElementsByTagName("sup");
	for (var i = 0; i < anchorTags.length ; i++){
		var ob1=anchorTags[i];
		if(ob1.id=="harv_ref-"+prm_name+"-"+prm_n){
			ob1.style.backgroundColor="#AAAAAA";//link in article text
		}else if(ob1.id=="harv_note-"+prm_name){
			ob1.style.backgroundColor="yellow";//big backlink
		}else if(ob1.id=="harv_note-"+prm_name+"-"+prm_n){
			ob1.style.backgroundColor="yellow"; //numbered backlink
		}else{	
			ob1.style.backgroundColor="";
		}
	}
	setBackground(prm_name);
}

function showRefsMode(n){
	var anchorTags = document.getElementsByTagName("sup");
	for (var i = 0; i < anchorTags.length ; i++){
		var ob1=anchorTags[i];
		if(ob1.id.indexOf("harv_ref-")==0){
			if(n==""){
				ob1.style.display = "";
				ob2=ob1.childNodes[0]; 
				ob3=ob2.childNodes[0]; 
				if(ob3.nodeValue.indexOf("*")>=0){
					t=ob2.title;
					ob3.nodeValue=t;
				};
			}else if(n=="hide"){
				ob1.style.display = "none";
			}else if (n=="short"){
				ob1.style.display = "";
				ob2=ob1.childNodes[0]; 
				ob3=ob2.childNodes[0]; 
				var t=ob3.nodeValue;
				if(ob1.childNodes.length>1){
					var p=ob1.childNodes[1].nodeValue;
					t=t+ob1.childNodes[1].nodeValue;
					ob1.childNodes[1].nodeValue="";
				}
				ob2.title=t;
				ob3.nodeValue="* ";
			}else{	
				ob1.style.display = "";
			}
		}
	}
}

this.changeFormat = function(){
	
	var s=state;
	if(s==""){
		s="short";
	}else if(s=="short"){	
		s="hide";
	}else if(s=="hide"){	
		s="";
	}
	state=s;
	showRefsMode(s);
}


function handler1(id){
	
	var arr=id.split("-");
	setRef(arr[1], arr[2]);
}

function handler2(id){
	var arr=id.split("-");
	if(arr[2]){
		setNote(arr[1], arr[2]);
	}else{
		setBack(arr[1]);
	}
}

this.onLoad = function(){
	if (wgAction=="view"){ //only for view pages
		var ok=0;
		//install events
		var anchorTags = document.getElementsByTagName("a");
		for (var i = 0; i < anchorTags.length ; i++){
			var ob1=anchorTags[i];
			
			if(ob1.href.indexOf("#harv_note-")>=0){
				ob1.onclick= function(){handler1(this.parentNode.id)};
			}else if(ob1.href.indexOf("#harv_ref-")>=0){
				ob1.onclick= function(){handler2(this.parentNode.id)};
				ok=1;
			}
		}
		
		//install the portlet
		if(ok==1){
			var hist; var url;
			if (!(hist = document.getElementById('ca-history') )) return;
			if (!(url = hist.getElementsByTagName('a')[0] )) return;
			if (!(url = url.href )) return;
			addPortletLink('p-cactions', 'javascript:HrvHighlight.changeFormat();',
						   'harvrefs', 'ca-harvrefs', 'Change format of harvard references', '');
			
			var s=state;
			if(s!="") showRefsMode(s);
		}
	}
}

}//obj

//Script is starting here
//if (doneOnloadHook) HrvHighlight.onLoad()
//else addOnloadHook(HrvHighlight.onLoad);